package gnu.jspengine;


import java.io.IOException;

import org.xml.sax.Parser;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

class JspXMLParser 
{
  private JspNode jspBody;
  /**
   * the name of the class of the sax parser for xml parsing
   */
  private String xmlParserClassName;
	
  public JspXMLParser(String xmlParserClassName) 
  {
    this.xmlParserClassName = xmlParserClassName;
  }
  void parse(StackedReader r, JspNode jspBody) 
    throws IOException 
  {
    this.jspBody = jspBody;
    Parser parser = null;
	
    try 
      {
	ClassLoader cl = this.getClass().getClassLoader(); 
	Class clas = null;
	if (cl == null) 
	  {
	    //  clas = ClassLoader.loadClass(xmlParserClassName);
	    throw new IOException("could not locate class loader for JspXMLParser");
	  } else 
	    {
	      clas = cl.loadClass(xmlParserClassName);
	    }
	parser = (org.xml.sax.Parser) clas.newInstance();
      } catch (ClassNotFoundException e) 
	{
	  throw new IOException(e.toString());
	} catch (InstantiationException e) 
	  {
	    throw new IOException(e.toString());
	  } catch (IllegalAccessException e) 
	    {
	      throw new IOException(e.toString());
	    }

    JspDocHandler  dh = new JspDocHandler();
    parser.setDocumentHandler(dh);

    dh.setJspBody(jspBody); 
    try 
      {
	parser.parse(new InputSource(r));
      } catch (SAXParseException e) 
	{
	  throw new ParseException(new Pos("fixme-filename",
					   e.getLineNumber()),
				   e.toString());
	} catch (SAXException e) 
	  {
	    throw new IOException(e.toString());
	  }
  }
}
