/*
  GNUJSP - a free JSP1.0 implementation
  Copyright (C) 2000, Carsten Heyl <alph@gjt.org>

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

package gnu.jspengine.xml;

import java.io.Writer;
import java.io.BufferedWriter;
import java.io.PrintWriter;
import java.io.IOException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

// FIXME: this should be a parameter because its dependedance of
// the XML/DOM package used
//  import org.apache.xerces.dom.DocumentImpl;
//  import org.apache.xml.serialize.XMLSerializer;
//  import org.apache.xml.serialize.OutputFormat;

/**
 * A hack class compatible with BufferedWriter
 * to support output to DOM tree.
 * It may be better to create a general JspSink which just
 * contains a BufferedReader where it is needed and other
 * attributes otherwise.
 */
public class DOMSink 
    extends java.io.BufferedWriter {

    private Document doc = null;
    private Element root = null;
    private Element currentElement = null;

    public DOMSink(Writer w) {
	super(w);

	/*
	// FIXME: DOM package specific
	// FIXME: set Public ID
	doc = new DocumentImpl();

	root = doc.createElement("jsp:root");
	doc.appendChild(root);
	root.setAttributeNode(doc.createAttribute("xmlns:jsp"));
	// FIXME: use local dtd!
	root.setAttribute("xmlns:jsp","http://java.sun.com/.../jsp_1_0.dtd");

	currentElement = root;
	*/
    }

    public Document getDocument() { return doc; }
    public Element getRoot() { return root; }
    public Element getCurrentElement() { return currentElement; }
    public void appendChild(Node e) { currentElement.appendChild(e); }
    public void pushNode(Node e) { 
	currentElement.appendChild(e); 
	currentElement = (Element) e;
    }
    public Node popNode() {
	Node n = currentElement;
	currentElement = (Element) n.getParentNode();
	return n;
    }

    public void writeDOM() 
	throws IOException
    {

      /*
	// default is UTF8
	String encoding = "UTF-8"; // "8859_1";
	// FIXME: encoding of BufferedWriter???
	PrintWriter out = new PrintWriter(this);
	
	// FIXME: xerces specific
	XMLSerializer xmlser = 
	    new XMLSerializer(out, 
			      new OutputFormat(doc, encoding, true));
	xmlser.serialize(doc);
      */
    }
}
